try:
    from aioredis.errors import (
        AuthError,
        BusyGroupError,
        ChannelClosedError,
        ConnectionClosedError,
        ConnectionForcedCloseError,
        MasterNotFoundError,
        MasterReplyError,
        MaxClientsError,
        MultiExecError,
        PipelineError,
        PoolClosedError,
        ProtocolError,
        ReadOnlyError,
        RedisError,
        ReplyError,
        SlaveNotFoundError,
        SlaveReplyError,
        WatchVariableError,
    )
except ImportError:
    from .._aioredis.errors import (
        AuthError,
        BusyGroupError,
        ChannelClosedError,
        ConnectionClosedError,
        ConnectionForcedCloseError,
        MasterNotFoundError,
        MasterReplyError,
        MaxClientsError,
        MultiExecError,
        PipelineError,
        PoolClosedError,
        ProtocolError,
        ReadOnlyError,
        RedisError,
        ReplyError,
        SlaveNotFoundError,
        SlaveReplyError,
        WatchVariableError,
    )


__all__ = (
    "AuthError",
    "BusyGroupError",
    "ChannelClosedError",
    "ConnectionClosedError",
    "ConnectionForcedCloseError",
    "MasterNotFoundError",
    "MasterReplyError",
    "MaxClientsError",
    "MultiExecError",
    "PipelineError",
    "PoolClosedError",
    "ProtocolError",
    "ReadOnlyError",
    "RedisError",
    "ReplyError",
    "SlaveNotFoundError",
    "SlaveReplyError",
    "WatchVariableError",
)
